declare type Nullable<T> = T | null;
export interface ASTNodeIntf {
    kind: ASTKinds;
}
export declare enum ASTKinds {
    complete_expression = "complete_expression",
    complete_expression_$0_1 = "complete_expression_$0_1",
    complete_expression_$0_2 = "complete_expression_$0_2",
    complete_expression_$0_3 = "complete_expression_$0_3",
    compound_expression_1 = "compound_expression_1",
    compound_expression_2 = "compound_expression_2",
    and_expression = "and_expression",
    and_expression_$0_1 = "and_expression_$0_1",
    and_expression_$0_2 = "and_expression_$0_2",
    and_expression_$0_3 = "and_expression_$0_3",
    and_expression_$1_1 = "and_expression_$1_1",
    and_expression_$1_2 = "and_expression_$1_2",
    and_expression_$1_3 = "and_expression_$1_3",
    or_expression = "or_expression",
    or_expression_$0_1 = "or_expression_$0_1",
    or_expression_$0_2 = "or_expression_$0_2",
    or_expression_$0_3 = "or_expression_$0_3",
    or_expression_$1_1 = "or_expression_$1_1",
    or_expression_$1_2 = "or_expression_$1_2",
    or_expression_$1_3 = "or_expression_$1_3",
    simple_expression_1 = "simple_expression_1",
    simple_expression_2 = "simple_expression_2",
    license_ref_expression_1 = "license_ref_expression_1",
    license_ref_expression_2 = "license_ref_expression_2",
    license_id_expression = "license_id_expression",
    wrapped_expression = "wrapped_expression",
    wrapped_expression_$0_1 = "wrapped_expression_$0_1",
    wrapped_expression_$0_2 = "wrapped_expression_$0_2",
    wrapped_expression_$0_3 = "wrapped_expression_$0_3",
    license_exception = "license_exception",
    license_ref_1 = "license_ref_1",
    license_ref_2 = "license_ref_2",
    license_ref_$0 = "license_ref_$0",
    license_ref_$1 = "license_ref_$1",
    license_ref_$2 = "license_ref_$2",
    WITH = "WITH",
    AND = "AND",
    OR = "OR",
    whitespace = "whitespace",
    license_ref_id = "license_ref_id",
    document_ref_id = "document_ref_id",
    idstring = "idstring",
    license_id = "license_id",
    $EOF = "$EOF"
}
export interface complete_expression {
    kind: ASTKinds.complete_expression;
    value: complete_expression_$0;
}
export declare type complete_expression_$0 = complete_expression_$0_1 | complete_expression_$0_2 | complete_expression_$0_3;
export declare type complete_expression_$0_1 = compound_expression;
export declare type complete_expression_$0_2 = wrapped_expression;
export declare type complete_expression_$0_3 = simple_expression;
export declare type compound_expression = compound_expression_1 | compound_expression_2;
export declare type compound_expression_1 = and_expression;
export declare type compound_expression_2 = or_expression;
export interface and_expression {
    kind: ASTKinds.and_expression;
    left: and_expression_$0;
    right: and_expression_$1;
}
export declare type and_expression_$0 = and_expression_$0_1 | and_expression_$0_2 | and_expression_$0_3;
export declare type and_expression_$0_1 = compound_expression;
export declare type and_expression_$0_2 = wrapped_expression;
export declare type and_expression_$0_3 = simple_expression;
export declare type and_expression_$1 = and_expression_$1_1 | and_expression_$1_2 | and_expression_$1_3;
export declare type and_expression_$1_1 = compound_expression;
export declare type and_expression_$1_2 = wrapped_expression;
export declare type and_expression_$1_3 = simple_expression;
export interface or_expression {
    kind: ASTKinds.or_expression;
    left: or_expression_$0;
    right: or_expression_$1;
}
export declare type or_expression_$0 = or_expression_$0_1 | or_expression_$0_2 | or_expression_$0_3;
export declare type or_expression_$0_1 = compound_expression;
export declare type or_expression_$0_2 = wrapped_expression;
export declare type or_expression_$0_3 = simple_expression;
export declare type or_expression_$1 = or_expression_$1_1 | or_expression_$1_2 | or_expression_$1_3;
export declare type or_expression_$1_1 = compound_expression;
export declare type or_expression_$1_2 = wrapped_expression;
export declare type or_expression_$1_3 = simple_expression;
export declare type simple_expression = simple_expression_1 | simple_expression_2;
export declare type simple_expression_1 = license_ref_expression;
export declare type simple_expression_2 = license_id_expression;
export declare type license_ref_expression = license_ref_expression_1 | license_ref_expression_2;
export interface license_ref_expression_1 {
    kind: ASTKinds.license_ref_expression_1;
    document_ref: document_ref_id;
    license_ref: license_ref_id;
    exception: Nullable<license_exception>;
}
export interface license_ref_expression_2 {
    kind: ASTKinds.license_ref_expression_2;
    license_ref: license_ref_id;
    exception: Nullable<license_exception>;
}
export interface license_id_expression {
    kind: ASTKinds.license_id_expression;
    license: license_id;
    exception: Nullable<license_exception>;
}
export interface wrapped_expression {
    kind: ASTKinds.wrapped_expression;
    value: wrapped_expression_$0;
}
export declare type wrapped_expression_$0 = wrapped_expression_$0_1 | wrapped_expression_$0_2 | wrapped_expression_$0_3;
export declare type wrapped_expression_$0_1 = compound_expression;
export declare type wrapped_expression_$0_2 = wrapped_expression;
export declare type wrapped_expression_$0_3 = simple_expression;
export interface license_exception {
    kind: ASTKinds.license_exception;
    exception: idstring;
}
export declare type license_ref = license_ref_1 | license_ref_2;
export interface license_ref_1 {
    kind: ASTKinds.license_ref_1;
    document_ref: license_ref_$0;
    license_ref: license_ref_$1;
}
export interface license_ref_2 {
    kind: ASTKinds.license_ref_2;
    license_ref: license_ref_$2;
}
export interface license_ref_$0 {
    kind: ASTKinds.license_ref_$0;
    prefix: string;
    value: idstring;
}
export interface license_ref_$1 {
    kind: ASTKinds.license_ref_$1;
    prefix: string;
    value: idstring;
}
export interface license_ref_$2 {
    kind: ASTKinds.license_ref_$2;
    prefix: string;
    value: idstring;
}
export interface WITH {
    kind: ASTKinds.WITH;
}
export interface AND {
    kind: ASTKinds.AND;
}
export interface OR {
    kind: ASTKinds.OR;
}
export declare type whitespace = string;
export interface license_ref_id {
    kind: ASTKinds.license_ref_id;
    prefix: string;
    value: string;
}
export interface document_ref_id {
    kind: ASTKinds.document_ref_id;
    prefix: string;
    value: string;
}
export declare type idstring = string;
export interface license_id {
    kind: ASTKinds.license_id;
    license: idstring;
}
export declare class Parser {
    private readonly input;
    private pos;
    private negating;
    private memoSafe;
    constructor(input: string);
    reset(pos: PosInfo): void;
    finished(): boolean;
    clearMemos(): void;
    protected $scope$compound_expression$memo: Map<number, [Nullable<compound_expression>, PosInfo]>;
    matchcomplete_expression($$dpth: number, $$cr?: ErrorTracker): Nullable<complete_expression>;
    matchcomplete_expression_$0($$dpth: number, $$cr?: ErrorTracker): Nullable<complete_expression_$0>;
    matchcomplete_expression_$0_1($$dpth: number, $$cr?: ErrorTracker): Nullable<complete_expression_$0_1>;
    matchcomplete_expression_$0_2($$dpth: number, $$cr?: ErrorTracker): Nullable<complete_expression_$0_2>;
    matchcomplete_expression_$0_3($$dpth: number, $$cr?: ErrorTracker): Nullable<complete_expression_$0_3>;
    matchcompound_expression($$dpth: number, $$cr?: ErrorTracker): Nullable<compound_expression>;
    matchcompound_expression_1($$dpth: number, $$cr?: ErrorTracker): Nullable<compound_expression_1>;
    matchcompound_expression_2($$dpth: number, $$cr?: ErrorTracker): Nullable<compound_expression_2>;
    matchand_expression($$dpth: number, $$cr?: ErrorTracker): Nullable<and_expression>;
    matchand_expression_$0($$dpth: number, $$cr?: ErrorTracker): Nullable<and_expression_$0>;
    matchand_expression_$0_1($$dpth: number, $$cr?: ErrorTracker): Nullable<and_expression_$0_1>;
    matchand_expression_$0_2($$dpth: number, $$cr?: ErrorTracker): Nullable<and_expression_$0_2>;
    matchand_expression_$0_3($$dpth: number, $$cr?: ErrorTracker): Nullable<and_expression_$0_3>;
    matchand_expression_$1($$dpth: number, $$cr?: ErrorTracker): Nullable<and_expression_$1>;
    matchand_expression_$1_1($$dpth: number, $$cr?: ErrorTracker): Nullable<and_expression_$1_1>;
    matchand_expression_$1_2($$dpth: number, $$cr?: ErrorTracker): Nullable<and_expression_$1_2>;
    matchand_expression_$1_3($$dpth: number, $$cr?: ErrorTracker): Nullable<and_expression_$1_3>;
    matchor_expression($$dpth: number, $$cr?: ErrorTracker): Nullable<or_expression>;
    matchor_expression_$0($$dpth: number, $$cr?: ErrorTracker): Nullable<or_expression_$0>;
    matchor_expression_$0_1($$dpth: number, $$cr?: ErrorTracker): Nullable<or_expression_$0_1>;
    matchor_expression_$0_2($$dpth: number, $$cr?: ErrorTracker): Nullable<or_expression_$0_2>;
    matchor_expression_$0_3($$dpth: number, $$cr?: ErrorTracker): Nullable<or_expression_$0_3>;
    matchor_expression_$1($$dpth: number, $$cr?: ErrorTracker): Nullable<or_expression_$1>;
    matchor_expression_$1_1($$dpth: number, $$cr?: ErrorTracker): Nullable<or_expression_$1_1>;
    matchor_expression_$1_2($$dpth: number, $$cr?: ErrorTracker): Nullable<or_expression_$1_2>;
    matchor_expression_$1_3($$dpth: number, $$cr?: ErrorTracker): Nullable<or_expression_$1_3>;
    matchsimple_expression($$dpth: number, $$cr?: ErrorTracker): Nullable<simple_expression>;
    matchsimple_expression_1($$dpth: number, $$cr?: ErrorTracker): Nullable<simple_expression_1>;
    matchsimple_expression_2($$dpth: number, $$cr?: ErrorTracker): Nullable<simple_expression_2>;
    matchlicense_ref_expression($$dpth: number, $$cr?: ErrorTracker): Nullable<license_ref_expression>;
    matchlicense_ref_expression_1($$dpth: number, $$cr?: ErrorTracker): Nullable<license_ref_expression_1>;
    matchlicense_ref_expression_2($$dpth: number, $$cr?: ErrorTracker): Nullable<license_ref_expression_2>;
    matchlicense_id_expression($$dpth: number, $$cr?: ErrorTracker): Nullable<license_id_expression>;
    matchwrapped_expression($$dpth: number, $$cr?: ErrorTracker): Nullable<wrapped_expression>;
    matchwrapped_expression_$0($$dpth: number, $$cr?: ErrorTracker): Nullable<wrapped_expression_$0>;
    matchwrapped_expression_$0_1($$dpth: number, $$cr?: ErrorTracker): Nullable<wrapped_expression_$0_1>;
    matchwrapped_expression_$0_2($$dpth: number, $$cr?: ErrorTracker): Nullable<wrapped_expression_$0_2>;
    matchwrapped_expression_$0_3($$dpth: number, $$cr?: ErrorTracker): Nullable<wrapped_expression_$0_3>;
    matchlicense_exception($$dpth: number, $$cr?: ErrorTracker): Nullable<license_exception>;
    matchlicense_ref($$dpth: number, $$cr?: ErrorTracker): Nullable<license_ref>;
    matchlicense_ref_1($$dpth: number, $$cr?: ErrorTracker): Nullable<license_ref_1>;
    matchlicense_ref_2($$dpth: number, $$cr?: ErrorTracker): Nullable<license_ref_2>;
    matchlicense_ref_$0($$dpth: number, $$cr?: ErrorTracker): Nullable<license_ref_$0>;
    matchlicense_ref_$1($$dpth: number, $$cr?: ErrorTracker): Nullable<license_ref_$1>;
    matchlicense_ref_$2($$dpth: number, $$cr?: ErrorTracker): Nullable<license_ref_$2>;
    matchWITH($$dpth: number, $$cr?: ErrorTracker): Nullable<WITH>;
    matchAND($$dpth: number, $$cr?: ErrorTracker): Nullable<AND>;
    matchOR($$dpth: number, $$cr?: ErrorTracker): Nullable<OR>;
    matchwhitespace($$dpth: number, $$cr?: ErrorTracker): Nullable<whitespace>;
    matchlicense_ref_id($$dpth: number, $$cr?: ErrorTracker): Nullable<license_ref_id>;
    matchdocument_ref_id($$dpth: number, $$cr?: ErrorTracker): Nullable<document_ref_id>;
    matchidstring($$dpth: number, $$cr?: ErrorTracker): Nullable<idstring>;
    matchlicense_id($$dpth: number, $$cr?: ErrorTracker): Nullable<license_id>;
    test(): boolean;
    parse(): ParseResult;
    mark(): PosInfo;
    private loop;
    private run;
    private choice;
    private regexAccept;
    private tryConsume;
    private noConsume;
    private negate;
    private memoise;
    private match$EOF;
}
export declare function parse(s: string): ParseResult;
export interface ParseResult {
    ast: Nullable<complete_expression>;
    errs: SyntaxErr[];
}
export interface PosInfo {
    readonly overallPos: number;
    readonly line: number;
    readonly offset: number;
}
export interface RegexMatch {
    readonly kind: "RegexMatch";
    readonly negated: boolean;
    readonly literal: string;
}
export declare type EOFMatch = {
    kind: "EOF";
    negated: boolean;
};
export declare type MatchAttempt = RegexMatch | EOFMatch;
export declare class SyntaxErr {
    pos: PosInfo;
    expmatches: MatchAttempt[];
    constructor(pos: PosInfo, expmatches: MatchAttempt[]);
    toString(): string;
}
declare class ErrorTracker {
    private mxpos;
    private regexset;
    private pmatches;
    record(pos: PosInfo, result: any, att: MatchAttempt): void;
    getErr(): SyntaxErr | null;
}
export {};
