"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SyntaxErr = exports.parse = exports.Parser = exports.ASTKinds = void 0;
var ASTKinds;
(function (ASTKinds) {
    ASTKinds["complete_expression"] = "complete_expression";
    ASTKinds["complete_expression_$0_1"] = "complete_expression_$0_1";
    ASTKinds["complete_expression_$0_2"] = "complete_expression_$0_2";
    ASTKinds["complete_expression_$0_3"] = "complete_expression_$0_3";
    ASTKinds["compound_expression_1"] = "compound_expression_1";
    ASTKinds["compound_expression_2"] = "compound_expression_2";
    ASTKinds["and_expression"] = "and_expression";
    ASTKinds["and_expression_$0_1"] = "and_expression_$0_1";
    ASTKinds["and_expression_$0_2"] = "and_expression_$0_2";
    ASTKinds["and_expression_$0_3"] = "and_expression_$0_3";
    ASTKinds["and_expression_$1_1"] = "and_expression_$1_1";
    ASTKinds["and_expression_$1_2"] = "and_expression_$1_2";
    ASTKinds["and_expression_$1_3"] = "and_expression_$1_3";
    ASTKinds["or_expression"] = "or_expression";
    ASTKinds["or_expression_$0_1"] = "or_expression_$0_1";
    ASTKinds["or_expression_$0_2"] = "or_expression_$0_2";
    ASTKinds["or_expression_$0_3"] = "or_expression_$0_3";
    ASTKinds["or_expression_$1_1"] = "or_expression_$1_1";
    ASTKinds["or_expression_$1_2"] = "or_expression_$1_2";
    ASTKinds["or_expression_$1_3"] = "or_expression_$1_3";
    ASTKinds["simple_expression_1"] = "simple_expression_1";
    ASTKinds["simple_expression_2"] = "simple_expression_2";
    ASTKinds["license_ref_expression_1"] = "license_ref_expression_1";
    ASTKinds["license_ref_expression_2"] = "license_ref_expression_2";
    ASTKinds["license_id_expression"] = "license_id_expression";
    ASTKinds["wrapped_expression"] = "wrapped_expression";
    ASTKinds["wrapped_expression_$0_1"] = "wrapped_expression_$0_1";
    ASTKinds["wrapped_expression_$0_2"] = "wrapped_expression_$0_2";
    ASTKinds["wrapped_expression_$0_3"] = "wrapped_expression_$0_3";
    ASTKinds["license_exception"] = "license_exception";
    ASTKinds["license_ref_1"] = "license_ref_1";
    ASTKinds["license_ref_2"] = "license_ref_2";
    ASTKinds["license_ref_$0"] = "license_ref_$0";
    ASTKinds["license_ref_$1"] = "license_ref_$1";
    ASTKinds["license_ref_$2"] = "license_ref_$2";
    ASTKinds["WITH"] = "WITH";
    ASTKinds["AND"] = "AND";
    ASTKinds["OR"] = "OR";
    ASTKinds["whitespace"] = "whitespace";
    ASTKinds["license_ref_id"] = "license_ref_id";
    ASTKinds["document_ref_id"] = "document_ref_id";
    ASTKinds["idstring"] = "idstring";
    ASTKinds["license_id"] = "license_id";
    ASTKinds["$EOF"] = "$EOF";
})(ASTKinds = exports.ASTKinds || (exports.ASTKinds = {}));
var Parser = /** @class */ (function () {
    function Parser(input) {
        this.negating = false;
        this.memoSafe = true;
        this.$scope$compound_expression$memo = new Map();
        this.pos = { overallPos: 0, line: 1, offset: 0 };
        this.input = input;
    }
    Parser.prototype.reset = function (pos) {
        this.pos = pos;
    };
    Parser.prototype.finished = function () {
        return this.pos.overallPos === this.input.length;
    };
    Parser.prototype.clearMemos = function () {
        this.$scope$compound_expression$memo.clear();
    };
    Parser.prototype.matchcomplete_expression = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$value;
            var $$res = null;
            if (true
                && ($scope$value = _this.matchcomplete_expression_$0($$dpth + 1, $$cr)) !== null
                && _this.match$EOF($$cr) !== null) {
                $$res = { kind: ASTKinds.complete_expression, value: $scope$value };
            }
            return $$res;
        });
    };
    Parser.prototype.matchcomplete_expression_$0 = function ($$dpth, $$cr) {
        var _this = this;
        return this.choice([
            function () { return _this.matchcomplete_expression_$0_1($$dpth + 1, $$cr); },
            function () { return _this.matchcomplete_expression_$0_2($$dpth + 1, $$cr); },
            function () { return _this.matchcomplete_expression_$0_3($$dpth + 1, $$cr); },
        ]);
    };
    Parser.prototype.matchcomplete_expression_$0_1 = function ($$dpth, $$cr) {
        return this.matchcompound_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchcomplete_expression_$0_2 = function ($$dpth, $$cr) {
        return this.matchwrapped_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchcomplete_expression_$0_3 = function ($$dpth, $$cr) {
        return this.matchsimple_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchcompound_expression = function ($$dpth, $$cr) {
        var _this = this;
        var fn = function () {
            return _this.choice([
                function () { return _this.matchcompound_expression_1($$dpth + 1, $$cr); },
                function () { return _this.matchcompound_expression_2($$dpth + 1, $$cr); },
            ]);
        };
        var $scope$pos = this.mark();
        var memo = this.$scope$compound_expression$memo.get($scope$pos.overallPos);
        if (memo !== undefined) {
            this.reset(memo[1]);
            return memo[0];
        }
        var $scope$oldMemoSafe = this.memoSafe;
        this.memoSafe = false;
        this.$scope$compound_expression$memo.set($scope$pos.overallPos, [null, $scope$pos]);
        var lastRes = null;
        var lastPos = $scope$pos;
        for (;;) {
            this.reset($scope$pos);
            var res = fn();
            var end = this.mark();
            if (end.overallPos <= lastPos.overallPos)
                break;
            lastRes = res;
            lastPos = end;
            this.$scope$compound_expression$memo.set($scope$pos.overallPos, [lastRes, lastPos]);
        }
        this.reset(lastPos);
        this.memoSafe = $scope$oldMemoSafe;
        return lastRes;
    };
    Parser.prototype.matchcompound_expression_1 = function ($$dpth, $$cr) {
        return this.matchand_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchcompound_expression_2 = function ($$dpth, $$cr) {
        return this.matchor_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchand_expression = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$left;
            var $scope$right;
            var $$res = null;
            if (true
                && ((_this.matchwhitespace($$dpth + 1, $$cr)) || true)
                && ($scope$left = _this.matchand_expression_$0($$dpth + 1, $$cr)) !== null
                && _this.matchAND($$dpth + 1, $$cr) !== null
                && ($scope$right = _this.matchand_expression_$1($$dpth + 1, $$cr)) !== null
                && ((_this.matchwhitespace($$dpth + 1, $$cr)) || true)) {
                $$res = { kind: ASTKinds.and_expression, left: $scope$left, right: $scope$right };
            }
            return $$res;
        });
    };
    Parser.prototype.matchand_expression_$0 = function ($$dpth, $$cr) {
        var _this = this;
        return this.choice([
            function () { return _this.matchand_expression_$0_1($$dpth + 1, $$cr); },
            function () { return _this.matchand_expression_$0_2($$dpth + 1, $$cr); },
            function () { return _this.matchand_expression_$0_3($$dpth + 1, $$cr); },
        ]);
    };
    Parser.prototype.matchand_expression_$0_1 = function ($$dpth, $$cr) {
        return this.matchcompound_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchand_expression_$0_2 = function ($$dpth, $$cr) {
        return this.matchwrapped_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchand_expression_$0_3 = function ($$dpth, $$cr) {
        return this.matchsimple_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchand_expression_$1 = function ($$dpth, $$cr) {
        var _this = this;
        return this.choice([
            function () { return _this.matchand_expression_$1_1($$dpth + 1, $$cr); },
            function () { return _this.matchand_expression_$1_2($$dpth + 1, $$cr); },
            function () { return _this.matchand_expression_$1_3($$dpth + 1, $$cr); },
        ]);
    };
    Parser.prototype.matchand_expression_$1_1 = function ($$dpth, $$cr) {
        return this.matchcompound_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchand_expression_$1_2 = function ($$dpth, $$cr) {
        return this.matchwrapped_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchand_expression_$1_3 = function ($$dpth, $$cr) {
        return this.matchsimple_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchor_expression = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$left;
            var $scope$right;
            var $$res = null;
            if (true
                && ((_this.matchwhitespace($$dpth + 1, $$cr)) || true)
                && ($scope$left = _this.matchor_expression_$0($$dpth + 1, $$cr)) !== null
                && _this.matchOR($$dpth + 1, $$cr) !== null
                && ($scope$right = _this.matchor_expression_$1($$dpth + 1, $$cr)) !== null
                && ((_this.matchwhitespace($$dpth + 1, $$cr)) || true)) {
                $$res = { kind: ASTKinds.or_expression, left: $scope$left, right: $scope$right };
            }
            return $$res;
        });
    };
    Parser.prototype.matchor_expression_$0 = function ($$dpth, $$cr) {
        var _this = this;
        return this.choice([
            function () { return _this.matchor_expression_$0_1($$dpth + 1, $$cr); },
            function () { return _this.matchor_expression_$0_2($$dpth + 1, $$cr); },
            function () { return _this.matchor_expression_$0_3($$dpth + 1, $$cr); },
        ]);
    };
    Parser.prototype.matchor_expression_$0_1 = function ($$dpth, $$cr) {
        return this.matchcompound_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchor_expression_$0_2 = function ($$dpth, $$cr) {
        return this.matchwrapped_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchor_expression_$0_3 = function ($$dpth, $$cr) {
        return this.matchsimple_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchor_expression_$1 = function ($$dpth, $$cr) {
        var _this = this;
        return this.choice([
            function () { return _this.matchor_expression_$1_1($$dpth + 1, $$cr); },
            function () { return _this.matchor_expression_$1_2($$dpth + 1, $$cr); },
            function () { return _this.matchor_expression_$1_3($$dpth + 1, $$cr); },
        ]);
    };
    Parser.prototype.matchor_expression_$1_1 = function ($$dpth, $$cr) {
        return this.matchcompound_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchor_expression_$1_2 = function ($$dpth, $$cr) {
        return this.matchwrapped_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchor_expression_$1_3 = function ($$dpth, $$cr) {
        return this.matchsimple_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchsimple_expression = function ($$dpth, $$cr) {
        var _this = this;
        return this.choice([
            function () { return _this.matchsimple_expression_1($$dpth + 1, $$cr); },
            function () { return _this.matchsimple_expression_2($$dpth + 1, $$cr); },
        ]);
    };
    Parser.prototype.matchsimple_expression_1 = function ($$dpth, $$cr) {
        return this.matchlicense_ref_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchsimple_expression_2 = function ($$dpth, $$cr) {
        return this.matchlicense_id_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchlicense_ref_expression = function ($$dpth, $$cr) {
        var _this = this;
        return this.choice([
            function () { return _this.matchlicense_ref_expression_1($$dpth + 1, $$cr); },
            function () { return _this.matchlicense_ref_expression_2($$dpth + 1, $$cr); },
        ]);
    };
    Parser.prototype.matchlicense_ref_expression_1 = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$document_ref;
            var $scope$license_ref;
            var $scope$exception;
            var $$res = null;
            if (true
                && ($scope$document_ref = _this.matchdocument_ref_id($$dpth + 1, $$cr)) !== null
                && _this.regexAccept(String.raw(templateObject_1 || (templateObject_1 = __makeTemplateObject(["(?::)"], ["(?::)"]))), $$dpth + 1, $$cr) !== null
                && ($scope$license_ref = _this.matchlicense_ref_id($$dpth + 1, $$cr)) !== null
                && (($scope$exception = _this.matchlicense_exception($$dpth + 1, $$cr)) || true)) {
                $$res = { kind: ASTKinds.license_ref_expression_1, document_ref: $scope$document_ref, license_ref: $scope$license_ref, exception: $scope$exception };
            }
            return $$res;
        });
    };
    Parser.prototype.matchlicense_ref_expression_2 = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$license_ref;
            var $scope$exception;
            var $$res = null;
            if (true
                && ($scope$license_ref = _this.matchlicense_ref_id($$dpth + 1, $$cr)) !== null
                && (($scope$exception = _this.matchlicense_exception($$dpth + 1, $$cr)) || true)) {
                $$res = { kind: ASTKinds.license_ref_expression_2, license_ref: $scope$license_ref, exception: $scope$exception };
            }
            return $$res;
        });
    };
    Parser.prototype.matchlicense_id_expression = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$license;
            var $scope$exception;
            var $$res = null;
            if (true
                && ($scope$license = _this.matchlicense_id($$dpth + 1, $$cr)) !== null
                && (($scope$exception = _this.matchlicense_exception($$dpth + 1, $$cr)) || true)) {
                $$res = { kind: ASTKinds.license_id_expression, license: $scope$license, exception: $scope$exception };
            }
            return $$res;
        });
    };
    Parser.prototype.matchwrapped_expression = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$value;
            var $$res = null;
            if (true
                && _this.regexAccept(String.raw(templateObject_2 || (templateObject_2 = __makeTemplateObject(["(?:()"], ["(?:\\()"]))), $$dpth + 1, $$cr) !== null
                && ((_this.matchwhitespace($$dpth + 1, $$cr)) || true)
                && ($scope$value = _this.matchwrapped_expression_$0($$dpth + 1, $$cr)) !== null
                && ((_this.matchwhitespace($$dpth + 1, $$cr)) || true)
                && _this.regexAccept(String.raw(templateObject_3 || (templateObject_3 = __makeTemplateObject(["(?:))"], ["(?:\\))"]))), $$dpth + 1, $$cr) !== null) {
                $$res = { kind: ASTKinds.wrapped_expression, value: $scope$value };
            }
            return $$res;
        });
    };
    Parser.prototype.matchwrapped_expression_$0 = function ($$dpth, $$cr) {
        var _this = this;
        return this.choice([
            function () { return _this.matchwrapped_expression_$0_1($$dpth + 1, $$cr); },
            function () { return _this.matchwrapped_expression_$0_2($$dpth + 1, $$cr); },
            function () { return _this.matchwrapped_expression_$0_3($$dpth + 1, $$cr); },
        ]);
    };
    Parser.prototype.matchwrapped_expression_$0_1 = function ($$dpth, $$cr) {
        return this.matchcompound_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchwrapped_expression_$0_2 = function ($$dpth, $$cr) {
        return this.matchwrapped_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchwrapped_expression_$0_3 = function ($$dpth, $$cr) {
        return this.matchsimple_expression($$dpth + 1, $$cr);
    };
    Parser.prototype.matchlicense_exception = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$exception;
            var $$res = null;
            if (true
                && _this.matchWITH($$dpth + 1, $$cr) !== null
                && ($scope$exception = _this.matchidstring($$dpth + 1, $$cr)) !== null) {
                $$res = { kind: ASTKinds.license_exception, exception: $scope$exception };
            }
            return $$res;
        });
    };
    Parser.prototype.matchlicense_ref = function ($$dpth, $$cr) {
        var _this = this;
        return this.choice([
            function () { return _this.matchlicense_ref_1($$dpth + 1, $$cr); },
            function () { return _this.matchlicense_ref_2($$dpth + 1, $$cr); },
        ]);
    };
    Parser.prototype.matchlicense_ref_1 = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$document_ref;
            var $scope$license_ref;
            var $$res = null;
            if (true
                && ($scope$document_ref = _this.matchlicense_ref_$0($$dpth + 1, $$cr)) !== null
                && _this.regexAccept(String.raw(templateObject_4 || (templateObject_4 = __makeTemplateObject(["(?::)"], ["(?::)"]))), $$dpth + 1, $$cr) !== null
                && ($scope$license_ref = _this.matchlicense_ref_$1($$dpth + 1, $$cr)) !== null) {
                $$res = { kind: ASTKinds.license_ref_1, document_ref: $scope$document_ref, license_ref: $scope$license_ref };
            }
            return $$res;
        });
    };
    Parser.prototype.matchlicense_ref_2 = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$license_ref;
            var $$res = null;
            if (true
                && ($scope$license_ref = _this.matchlicense_ref_$2($$dpth + 1, $$cr)) !== null) {
                $$res = { kind: ASTKinds.license_ref_2, license_ref: $scope$license_ref };
            }
            return $$res;
        });
    };
    Parser.prototype.matchlicense_ref_$0 = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$prefix;
            var $scope$value;
            var $$res = null;
            if (true
                && ($scope$prefix = _this.regexAccept(String.raw(templateObject_5 || (templateObject_5 = __makeTemplateObject(["(?:DocumentRef-)"], ["(?:DocumentRef-)"]))), $$dpth + 1, $$cr)) !== null
                && ($scope$value = _this.matchidstring($$dpth + 1, $$cr)) !== null) {
                $$res = { kind: ASTKinds.license_ref_$0, prefix: $scope$prefix, value: $scope$value };
            }
            return $$res;
        });
    };
    Parser.prototype.matchlicense_ref_$1 = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$prefix;
            var $scope$value;
            var $$res = null;
            if (true
                && ($scope$prefix = _this.regexAccept(String.raw(templateObject_6 || (templateObject_6 = __makeTemplateObject(["(?:LicenseRef-)"], ["(?:LicenseRef-)"]))), $$dpth + 1, $$cr)) !== null
                && ($scope$value = _this.matchidstring($$dpth + 1, $$cr)) !== null) {
                $$res = { kind: ASTKinds.license_ref_$1, prefix: $scope$prefix, value: $scope$value };
            }
            return $$res;
        });
    };
    Parser.prototype.matchlicense_ref_$2 = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$prefix;
            var $scope$value;
            var $$res = null;
            if (true
                && ($scope$prefix = _this.regexAccept(String.raw(templateObject_7 || (templateObject_7 = __makeTemplateObject(["(?:LicenseRef-)"], ["(?:LicenseRef-)"]))), $$dpth + 1, $$cr)) !== null
                && ($scope$value = _this.matchidstring($$dpth + 1, $$cr)) !== null) {
                $$res = { kind: ASTKinds.license_ref_$2, prefix: $scope$prefix, value: $scope$value };
            }
            return $$res;
        });
    };
    Parser.prototype.matchWITH = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $$res = null;
            if (true
                && _this.matchwhitespace($$dpth + 1, $$cr) !== null
                && _this.regexAccept(String.raw(templateObject_8 || (templateObject_8 = __makeTemplateObject(["(?:WITH)"], ["(?:WITH)"]))), $$dpth + 1, $$cr) !== null
                && _this.matchwhitespace($$dpth + 1, $$cr) !== null) {
                $$res = { kind: ASTKinds.WITH, };
            }
            return $$res;
        });
    };
    Parser.prototype.matchAND = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $$res = null;
            if (true
                && _this.matchwhitespace($$dpth + 1, $$cr) !== null
                && _this.regexAccept(String.raw(templateObject_9 || (templateObject_9 = __makeTemplateObject(["(?:AND)"], ["(?:AND)"]))), $$dpth + 1, $$cr) !== null
                && _this.matchwhitespace($$dpth + 1, $$cr) !== null) {
                $$res = { kind: ASTKinds.AND, };
            }
            return $$res;
        });
    };
    Parser.prototype.matchOR = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $$res = null;
            if (true
                && _this.matchwhitespace($$dpth + 1, $$cr) !== null
                && _this.regexAccept(String.raw(templateObject_10 || (templateObject_10 = __makeTemplateObject(["(?:OR)"], ["(?:OR)"]))), $$dpth + 1, $$cr) !== null
                && _this.matchwhitespace($$dpth + 1, $$cr) !== null) {
                $$res = { kind: ASTKinds.OR, };
            }
            return $$res;
        });
    };
    Parser.prototype.matchwhitespace = function ($$dpth, $$cr) {
        return this.regexAccept(String.raw(templateObject_11 || (templateObject_11 = __makeTemplateObject(["(?:[s\t\n]+)"], ["(?:[\\s\\t\\n]+)"]))), $$dpth + 1, $$cr);
    };
    Parser.prototype.matchlicense_ref_id = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$prefix;
            var $scope$value;
            var $$res = null;
            if (true
                && ($scope$prefix = _this.regexAccept(String.raw(templateObject_12 || (templateObject_12 = __makeTemplateObject(["(?:LicenseRef-)"], ["(?:LicenseRef-)"]))), $$dpth + 1, $$cr)) !== null
                && ($scope$value = _this.regexAccept(String.raw(templateObject_13 || (templateObject_13 = __makeTemplateObject(["(?:[a-zA-Z0-9-.]+)"], ["(?:[a-zA-Z0-9\\-\\.]+)"]))), $$dpth + 1, $$cr)) !== null) {
                $$res = { kind: ASTKinds.license_ref_id, prefix: $scope$prefix, value: $scope$value };
            }
            return $$res;
        });
    };
    Parser.prototype.matchdocument_ref_id = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$prefix;
            var $scope$value;
            var $$res = null;
            if (true
                && ($scope$prefix = _this.regexAccept(String.raw(templateObject_14 || (templateObject_14 = __makeTemplateObject(["(?:DocumentRef-)"], ["(?:DocumentRef-)"]))), $$dpth + 1, $$cr)) !== null
                && ($scope$value = _this.regexAccept(String.raw(templateObject_15 || (templateObject_15 = __makeTemplateObject(["(?:[a-zA-Z0-9-.]+)"], ["(?:[a-zA-Z0-9\\-\\.]+)"]))), $$dpth + 1, $$cr)) !== null) {
                $$res = { kind: ASTKinds.document_ref_id, prefix: $scope$prefix, value: $scope$value };
            }
            return $$res;
        });
    };
    Parser.prototype.matchidstring = function ($$dpth, $$cr) {
        return this.regexAccept(String.raw(templateObject_16 || (templateObject_16 = __makeTemplateObject(["(?:[a-zA-Z0-9 ][a-zA-Z0-9.-]*[a-zA-Z0-9]++?+?)"], ["(?:[a-zA-Z0-9 ][a-zA-Z0-9\\.\\-]*[a-zA-Z0-9]+\\+?\\+?)"]))), $$dpth + 1, $$cr);
    };
    Parser.prototype.matchlicense_id = function ($$dpth, $$cr) {
        var _this = this;
        return this.run($$dpth, function () {
            var $scope$license;
            var $$res = null;
            if (true
                && ($scope$license = _this.matchidstring($$dpth + 1, $$cr)) !== null
                && ((_this.regexAccept(String.raw(templateObject_17 || (templateObject_17 = __makeTemplateObject(["(?:+)"], ["(?:\\+)"]))), $$dpth + 1, $$cr)) || true)) {
                $$res = { kind: ASTKinds.license_id, license: $scope$license };
            }
            return $$res;
        });
    };
    Parser.prototype.test = function () {
        var mrk = this.mark();
        var res = this.matchcomplete_expression(0);
        var ans = res !== null;
        this.reset(mrk);
        return ans;
    };
    Parser.prototype.parse = function () {
        var mrk = this.mark();
        var res = this.matchcomplete_expression(0);
        if (res)
            return { ast: res, errs: [] };
        this.reset(mrk);
        var rec = new ErrorTracker();
        this.clearMemos();
        this.matchcomplete_expression(0, rec);
        var err = rec.getErr();
        return { ast: res, errs: err !== null ? [err] : [] };
    };
    Parser.prototype.mark = function () {
        return this.pos;
    };
    Parser.prototype.loop = function (func, star) {
        if (star === void 0) { star = false; }
        var mrk = this.mark();
        var res = [];
        for (;;) {
            var t = func();
            if (t === null) {
                break;
            }
            res.push(t);
        }
        if (star || res.length > 0) {
            return res;
        }
        this.reset(mrk);
        return null;
    };
    Parser.prototype.run = function ($$dpth, fn) {
        var mrk = this.mark();
        var res = fn();
        if (res !== null)
            return res;
        this.reset(mrk);
        return null;
    };
    Parser.prototype.choice = function (fns) {
        var e_1, _a;
        try {
            for (var fns_1 = __values(fns), fns_1_1 = fns_1.next(); !fns_1_1.done; fns_1_1 = fns_1.next()) {
                var f = fns_1_1.value;
                var res = f();
                if (res !== null) {
                    return res;
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (fns_1_1 && !fns_1_1.done && (_a = fns_1.return)) _a.call(fns_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return null;
    };
    Parser.prototype.regexAccept = function (match, dpth, cr) {
        var _this = this;
        return this.run(dpth, function () {
            var reg = new RegExp(match, "y");
            var mrk = _this.mark();
            reg.lastIndex = mrk.overallPos;
            var res = _this.tryConsume(reg);
            if (cr) {
                cr.record(mrk, res, {
                    kind: "RegexMatch",
                    // We substring from 3 to len - 1 to strip off the
                    // non-capture group syntax added as a WebKit workaround
                    literal: match.substring(3, match.length - 1),
                    negated: _this.negating,
                });
            }
            return res;
        });
    };
    Parser.prototype.tryConsume = function (reg) {
        var res = reg.exec(this.input);
        if (res) {
            var lineJmp = 0;
            var lind = -1;
            for (var i = 0; i < res[0].length; ++i) {
                if (res[0][i] === "\n") {
                    ++lineJmp;
                    lind = i;
                }
            }
            this.pos = {
                overallPos: reg.lastIndex,
                line: this.pos.line + lineJmp,
                offset: lind === -1 ? this.pos.offset + res[0].length : (res[0].length - lind - 1)
            };
            return res[0];
        }
        return null;
    };
    Parser.prototype.noConsume = function (fn) {
        var mrk = this.mark();
        var res = fn();
        this.reset(mrk);
        return res;
    };
    Parser.prototype.negate = function (fn) {
        var mrk = this.mark();
        var oneg = this.negating;
        this.negating = !oneg;
        var res = fn();
        this.negating = oneg;
        this.reset(mrk);
        return res === null ? true : null;
    };
    Parser.prototype.memoise = function (rule, memo) {
        var $scope$pos = this.mark();
        var $scope$memoRes = memo.get($scope$pos.overallPos);
        if (this.memoSafe && $scope$memoRes !== undefined) {
            this.reset($scope$memoRes[1]);
            return $scope$memoRes[0];
        }
        var $scope$result = rule();
        if (this.memoSafe)
            memo.set($scope$pos.overallPos, [$scope$result, this.mark()]);
        return $scope$result;
    };
    Parser.prototype.match$EOF = function (et) {
        var res = this.finished() ? { kind: ASTKinds.$EOF } : null;
        if (et)
            et.record(this.mark(), res, { kind: "EOF", negated: this.negating });
        return res;
    };
    return Parser;
}());
exports.Parser = Parser;
function parse(s) {
    var p = new Parser(s);
    return p.parse();
}
exports.parse = parse;
var SyntaxErr = /** @class */ (function () {
    function SyntaxErr(pos, expmatches) {
        this.pos = pos;
        this.expmatches = __spreadArray([], __read(expmatches), false);
    }
    SyntaxErr.prototype.toString = function () {
        return "Syntax Error at line ".concat(this.pos.line, ":").concat(this.pos.offset, ". Expected one of ").concat(this.expmatches.map(function (x) { return x.kind === "EOF" ? " EOF" : " ".concat(x.negated ? 'not ' : '', "'").concat(x.literal, "'"); }));
    };
    return SyntaxErr;
}());
exports.SyntaxErr = SyntaxErr;
var ErrorTracker = /** @class */ (function () {
    function ErrorTracker() {
        this.mxpos = { overallPos: -1, line: -1, offset: -1 };
        this.regexset = new Set();
        this.pmatches = [];
    }
    ErrorTracker.prototype.record = function (pos, result, att) {
        if ((result === null) === att.negated)
            return;
        if (pos.overallPos > this.mxpos.overallPos) {
            this.mxpos = pos;
            this.pmatches = [];
            this.regexset.clear();
        }
        if (this.mxpos.overallPos === pos.overallPos) {
            if (att.kind === "RegexMatch") {
                if (!this.regexset.has(att.literal))
                    this.pmatches.push(att);
                this.regexset.add(att.literal);
            }
            else {
                this.pmatches.push(att);
            }
        }
    };
    ErrorTracker.prototype.getErr = function () {
        if (this.mxpos.overallPos !== -1)
            return new SyntaxErr(this.mxpos, this.pmatches);
        return null;
    };
    return ErrorTracker;
}());
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5, templateObject_6, templateObject_7, templateObject_8, templateObject_9, templateObject_10, templateObject_11, templateObject_12, templateObject_13, templateObject_14, templateObject_15, templateObject_16, templateObject_17;
