import { licenses, Licenses, License, exceptions, Exceptions, Exception } from './data';
export { licenses, Licenses, License, exceptions, Exceptions, Exception };
/**
 * Fix the given license identifier, if possible, or return it unchanged.
 *
 * @param identifier SPDX license identifier to "fix" if possible
 * @returns A corrected SPDX license identifier or the original, if no suitable "fix" was found
 */
export declare function correctLicenseId(identifier: string): string;
/**
 * Fix the given exception identifier, if possible, or return it unchanged.
 *
 * @param identifier SPDX exception identifier to "fix" if possible
 * @returns A corrected SPDX exception identifier or the original, if no suitable "fix" was found
 */
export declare function correctExceptionId(identifier: string, associatedLicense?: string): string;
export declare function isKnownLicenseId(id: string): boolean;
export declare function isKnownExceptionId(id: string): boolean;
