"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parse = exports.LiberalParser = void 0;
var assert_1 = __importDefault(require("assert"));
var LiberalParser = __importStar(require("../codegen/parser_liberal"));
exports.LiberalParser = LiberalParser;
var licenses_1 = require("../licenses");
var extractErrorMessage = function (tree) {
    if (tree.errs.length === 0)
        return undefined;
    return tree.errs.map(function (element) { return element.toString(); }).join('\n');
};
function parse(input) {
    var _a;
    var reduceNode = function (node) {
        if (!node) {
            return null;
        }
        else if (node.kind === LiberalParser.ASTKinds.or_expression) {
            return {
                conjunction: 'or',
                left: reduceNode(node.left),
                right: reduceNode(node.right)
            };
        }
        else if (node.kind === LiberalParser.ASTKinds.and_expression) {
            return {
                conjunction: 'and',
                left: reduceNode(node.left),
                right: reduceNode(node.right)
            };
        }
        else if (node.kind === LiberalParser.ASTKinds.license_exception) {
            return (0, licenses_1.correctExceptionId)(reduceNode(node.value));
        }
        else if (node.kind === LiberalParser.ASTKinds.simple_expression) {
            var license = (0, licenses_1.correctLicenseId)(reduceNode(node.value));
            var exception = reduceNode(node.exception);
            if (exception) {
                return { license: license, exception: exception };
            }
            else {
                return { license: license };
            }
        }
        else if (node.kind === LiberalParser.ASTKinds.words_expression) {
            var head = node.value.prefix.head.value;
            var tail = node.value.prefix.tail ? reduceNode(node.value.prefix.tail.rest) : '';
            return (head + ' ' + tail).trim();
        }
        else if (node.kind === LiberalParser.ASTKinds.words) {
            if (node.tail) {
                return (node.head.value + ' ' + reduceNode(node.tail.rest)).trim();
            }
            else {
                return node.head.value;
            }
        }
        else if (node.kind === LiberalParser.ASTKinds.wrapped_expression) {
            return reduceNode(node.value);
        }
        /* istanbul ignore next */ assert_1.default.fail("convertNodeWithCorrections() did not recognize input: ".concat(JSON.stringify(node)));
    };
    var p = new LiberalParser.Parser(input);
    var tree = p.parse();
    return { parse: tree, expression: reduceNode((_a = tree.ast) === null || _a === void 0 ? void 0 : _a.value), error: extractErrorMessage(tree) };
}
exports.parse = parse;
